<div id="header">
  <app-header></app-header>
</div>
<div class="container-fluid">
  <div id="content-wrapper" class="d-flex flex-row">
    <div id="sidebar"><app-sidebar></app-sidebar></div>
    <div id="main-container-gestionnaire-roles" class="container-fluid d-flex flex-column">
      <div id="title-container" class="container-fluid d-flex justify-content-between align-items-center p-4">
        <div class="dashboard-title d-flex flex-row align-items-center  p-5">
          <span><h1>GESTIONNAIRE DE BUGS</h1></span>
        </div>
        <app-add-bug-popup [typesErreurs]="typesErreurs" [loggedInUser]="loggedInUser" [testPlans]="testPlans"></app-add-bug-popup>
      </div>
      <div class="accordion accordion-flush" id="accordionFlushExample">
        <div class="accordion-item "
             *ngFor="let bug of bugs; index as index "
             id="{{ bug?.id }}">
          <h2 class="accordion-header" id="flush-heading{{ bug?.id }}">
            <button class="accordion-button collapsed d-flex flex-row justify-content-between align-items-center "
                    type="button" data-bs-toggle="collapse"
                    [attr.data-bs-target]="'#flush-collapse' +
                    bug.id " aria-expanded="false"
                    [attr.aria-controls]="'flush-collapse' +
                    bug?.id ">
              <div class="d-flex flex-row flex-grow-1 d-flex align-items-center">
                <span *ngIf="!bug?.archive" class="actif status d-flex align-items-center" (click)="onDelete($event, bug)">non-résolu</span>
                <span *ngIf="bug?.archive" class="inactif status d-flex align-items-center" (click)="onDelete($event, bug)">résolu</span>
                <span *ngIf="bug?.typeErreur?.priorite && bug?.typeErreur?.priorite == 1"
                      style="background-color: red"
                      class="priorite status d-flex align-items-center">urgent</span>
                <span *ngIf="bug?.typeErreur?.priorite && bug?.typeErreur?.priorite == 2"
                      style="background-color: orange"
                      class="priorite status d-flex align-items-center">important</span>
                <span *ngIf="bug?.typeErreur?.priorite && bug?.typeErreur?.priorite == 3"
                      style="background-color: yellowgreen"
                      class="priorite status d-flex align-items-center">standard</span>
                <span *ngIf="bug?.typeErreur?.priorite && bug?.typeErreur?.priorite == 4"
                      style="background-color: yellow"
                      class="priorite status d-flex align-items-center">optionnel</span>
                <span *ngIf="bug?.typeErreur?.niveau && bug?.typeErreur?.niveau == 1"
                      [style.background]="bug?.typeErreur?.couleur"
                      class="niveau status d-flex align-items-center">critique</span>
                <span *ngIf="bug?.typeErreur?.niveau && bug?.typeErreur?.niveau == 2"
                      [style.background]="bug?.typeErreur?.couleur"
                      class="niveau status d-flex align-items-center">modéré</span>
                <span *ngIf="bug?.typeErreur?.niveau && bug?.typeErreur?.niveau == 3"
                      [style.background]="bug?.typeErreur?.couleur"
                      class="niveau status d-flex align-items-center">standard</span>
                <span *ngIf="bug?.typeErreur?.niveau && bug?.typeErreur?.niveau == 4"
                      [style.background]="bug?.typeErreur?.couleur"
                      class="niveau status d-flex align-items-center">faible</span>


                <!--<span class="plan-title d-flex align-items-center">{{ (plan.nom.length>25)? (plan.nom | slice:0:25)+'...':(plan.nom) }}</span>-->
                <span class="plan-title d-flex align-items-center me-3">{{ bug?.typeErreur?.nom}}</span><span *ngIf="bug.fonctionnalite" class="me-3">{{bug?.fonctionnalite?.nom}}</span>
                <span class="version me-1">v.{{ bug?.version_ouvert }}</span>
                 -
                <span class="date ms-1">{{ bug?.date | date:'d/MM/yy - h:mm':'fr'}}</span>
              </div>
              <div>
                <span class="edit" (click)="onClick($event, bug)">
                  <i class="fa-solid fa-pen" aria-hidden="true"></i> <!-- Compliant icon fonts usage -->
                </span>
              </div>
            </button>
          </h2>
          <div id="flush-collapse{{ bug?.id }}" class="accordion-collapse collapse"
               [attr.aria-labelledby]="'flush-heading' +
               bug.id "
               data-bs-parent="#accordionFlushExample">
            <div class="ps-5 pe-5">
              <table class="bugs-table w-100">
                <caption class="ms-1">Détails du Bug</caption>
                <tr>
                  <th scope="col">ID</th>
                  <td>{{ bug?.id }}</td>
                </tr>
                <tr>
                  <th scope="col">DETAILS</th>
                  <td>{{ bug?.fonctionnalite?.details }}</td>
                </tr>
                <tr>
                  <th scope="col">COMMENTAIRE</th>
                  <td>{{ bug?.commentaire }}</td>
                </tr>
                <tr>
                  <th scope="col">SCENARIO</th>
                  <td>{{ bug?.fonctionnalite?.scenario }}</td>
                </tr>
                <tr>
                  <th scope="col">RESULTAT ATTENDU</th>
                  <td>{{ bug?.fonctionnalite?.resultatAttendu }}</td>
                </tr>
                <tr>
                  <th scope="col">PROJET</th>
                  <td>{{ bug?.projet_projet_id?.nom }}</td>
                </tr>
                <tr>
                  <th scope="col">PLAN DE TESTS</th>
                  <td>{{ bug?.testPlan?.nom }}</td>
                </tr>
                <tr>
                  <th scope="col">GROUPE FONCTIONNALITE</th>
                  <td>{{ bug?.groupeFonctionnalites?.nom }}</td>
                </tr>
                <tr>
                  <th scope="col">FONCTIONNALITE</th>
                  <td>{{ bug?.fonctionnalite?.nom }}</td>
                </tr>
                <tr>
                  <th scope="col">BETA TESTEUR</th>
                  <td>{{ bug?.betaTesteur?.prenom }} {{ bug?.betaTesteur?.nom }}</td>
                </tr>
                <tr>
                  <th scope="col">ASSIGNE A</th>
                  <td>{{ bug?.assigne_a_utilisateur_id?.prenom }} {{ bug?.assigne_a_utilisateur_id?.nom }}</td>
                </tr>
              </table>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
<!-- modal -->
<!-- Modal EDIT Plan-->
<div class="modal" id="myModal" [style.display]="showModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Détails du bug : {{editBug?.id}} - {{ editBug?.typeErreur?.nom }}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('editModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <form #editForm="ngForm" >
          <div class="form-group">
            <input
              type="hidden"
              [ngModel]="editBug?.id"
              name="id"
              id="id"
            />
            <input
              type="hidden"
              [ngModel]="editBug?.date"
              name="date"
              id="date"
            />
            <input
              type="hidden"
              [ngModel]="editBug?.version_ouvert"
              name="version_ouvert"
              id="version_ouvert"
            />
            <input
              type="hidden"
              [ngModel]="editBug?.projet_projet_id"
              name="projet_projet_id"
              id="projet_projet_id"
            />
            <input
              type="hidden"
              [ngModel]="editBug?.groupeFonctionnalites"
              name="groupeFonctionnalites"
              id="groupeFonctionnalites"
            />
            <input
            type="hidden"
            [ngModel]="editBug?.betaTesteur"
            name="betaTesteur"
            id="betaTesteur"
          />
            <input
              type="hidden"
              [ngModel]="editBug?.fonctionnalite"
              name="fonctionnalite"
              id="fonctionnalite"
            />
            <input
              type="hidden"
              [ngModel]="editBug?.testPlan"
              name="testPlan"
              id="resultatAttendu"
            />
          </div>
          <div class="form-group">
            <label class="mb-1" for="details">Détails</label>
            <textarea
              class="form-control mb-2"
              [ngModel]="editBug?.details"
              id="details"
              name="details"
            ></textarea>
          </div>
          <div class="form-group">
            <label class="mb-1" for="commentaire">Commentaire</label>
            <textarea
              class="form-control mb-2"
              [ngModel]="editBug?.commentaire"
              id="commentaire"
              name="commentaire"
            ></textarea>
          </div>
          <div class="form-group">
            <label class="mb-1 w-100" for="typeErreur">Type d'Erreur</label>
            <select [ngModel]="editBug?.typeErreur"
                    [compareWith]="compareFn"
                    name="typeErreur"
                    id="typeErreur"
                    class="w-100"
            >
              <option value="">Choisissez un type d'erreur</option>
              <option *ngFor="let typeErreur of typesErreurs; index as index;"
                      [ngValue]="typeErreur"
                      [selected]="editBug?.typeErreur?.id == typeErreur?.id ? true : null"
              >{{ typeErreur?.nom }}</option>
            </select>
          </div>
          <div class="form-group">
            <label class="mb-1 w-100" for="archive" >Status</label>
            <select [ngModel]="editBug?.archive"
                    name="archive"
                    id="archive"
                    class="w-100"
            >
              <option value="false"
                      [selected]="editBug?.archive === false"
              >actif</option>
              <option
                value="true"
                [selected]="editBug?.archive === true"
              >inactif</option>
            </select>
          </div>
          <div class="form-group">
            <label class="mb-1 w-100" for="assigne_a_utilisateur_id" >Assigner le bug à :</label>
            <select [ngModel]="editBug?.assigne_a_utilisateur_id"
                    [compareWith]="compare"
                    name="assigne_a_utilisateur_id"
                    id="assigne_a_utilisateur_id"
                    class="w-100"
            >
              <option *ngFor="let dev of devs; index as index; "
                      [ngValue]="dev"
                      [selected]="editBug?.assigne_a_utilisateur_id?.id == dev.id ? true : null"
                      (click)="setItem('developpeur', dev)">
              {{ dev?.prenom }} {{ dev?.nom }}</option>
            </select>
          </div>
          <div class="mt-3 mb-2">
            <button class="btn btn-primary w-100" (click)="onSubmit(editForm.value)" [disabled]="editForm.invalid">Sauvegarder</button>
          </div>
          <div class="mt-2 mb-2">
            <button class="btn btn-secondary w-100" type="reset" (click)="hide('editModal')">Annuler</button>
          </div>
        </form>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red;font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- Modal DELETE Plan-->
<div class="modal" id="deleteModal" [style.display]="showDeleteModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Archiver : {{deleteBug?.id}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="hide('deleteModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <div class="form-group">
          <p *ngIf="deleteBug?.archive == true" class="mt-3 mb-5" >Vous êtes sur le point de de passer le statut de bug #{{deleteBug?.id}} à résolu. <br/><br/>
            Êtes-vous sûr.e de vouloir continuer ?</p>
          <p *ngIf="deleteBug?.archive == false" class="mt-3 mb-5" >Vous êtes sur le point de de passer le statut de bug #{{deleteBug?.id}} à "non-résolu". <br/><br/>
            Êtes-vous sûr.e de vouloir continuer ?</p>
        </div>
          <div class="mt-3 mb-2">
            <button *ngIf="deleteBug?.archive == true" class="btn btn-danger w-100" (click)="onArchiveFonctionnalite(deleteBug)" data-dismiss="modal">Activer</button>
            <button *ngIf="deleteBug?.archive == false" class="btn btn-danger w-100" (click)="onArchiveFonctionnalite(deleteBug)" data-dismiss="modal">Désactiver</button>
          </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- Modal SHOW PERIODICITE Plan-->
<div class="modal" id="setPeriodiciteModal" [style.display]="showPeriodiciteModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Définir la périodicité : {{setPeriodicite?.id}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="hide('setPeriodiciteModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <form #periodiciteForm="ngForm" >

          <div class="form-group">
            <label class="mb-1 me-2" for="periodicite">Périodicité :</label>
            <select
                    name="periodicite"
                    id="periodicite"
            >
              <option value="1 mois"

              >1 mois</option>
              <option
                value="2 mois"

              >2 mois</option>
              <option
                value="3 mois"

              >3 mois</option>
              <option
                value="4 mois"

              >4 mois</option>
              <option
                value="5 mois"

              >5 mois</option>
              <option
                value="6 mois"

              >6 mois</option>
              <option
                value="7 mois"

              >7 mois</option>
              <option
                value="8 mois"

              >8 mois</option>
              <option
                value="9 mois"

              >9 mois</option>
              <option
                value="10 mois"

              >10 mois</option>
              <option
                value="11 mois"

              >11 mois</option>
              <option
                value="12 mois"

              >12 mois</option>
            </select>
          </div>
        </form>
        <div class="mt-3 mb-2">
          <button class="btn btn-primary w-100" (click)="onModifyPeriodicite(periodiciteForm.value)" data-dismiss="modal">Enregistrer</button>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- Modal SHOW PRIORITE Plan-->
<div class="modal" id="setPrioriteModal" [style.display]="showPrioriteModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Définir la priorité : {{setPriorite?.id}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="hide('setPrioriteModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <form #prioriteForm="ngForm" >
          <div class="form-group">
            <label class="mb-1 me-2" for="priorite">Priorité :</label>
            <select ngModel="{{setPriorite}}"
                    name="priorite"
                    id="priorite"
            >
              <option value="1"

              >urgent</option>
              <option
                value="2"

              >important</option>
              <option
                value="3"

              >standard</option>
              <option
                value="4"

              >optionnel</option>
            </select>
          </div>
        </form>
        <div class="mt-3 mb-2">
          <button class="btn btn-primary w-100" data-dismiss="modal">Enregistrer</button>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>
